INTERRUPT       equ     10h
;INT_SEG         equ     3909h           ; SEG:OFF of instruction after the
;INT_OFF         equ     0306h           ; calling interrupt
;CHANGE_SEG      equ     12C7h           ; SEG:OFF of instruction to change
;CHANGE_OFF      equ     3BFAh

OVERLAY SEGMENT para 'code'
        ASSUME CS:OVERLAY,DS:OVERLAY
        ORG 100h

START:JMP INITCODE

;----------------------------------------------------------

OLDINT  DW      0,0
ADDR_OFF        equ     <word ptr[bp+2]>
ADDR_SEG        equ     <word ptr[bp+4]>

CR              equ     0Dh
LF              equ     0Ah
BEEP            equ     07h
EOS             equ     '$'

;DISPLACEMENT    equ     CHANGE_SEG - INT_SEG

;----------------------------------------------------------

NEWINT proc far
        PUSHF
        CMP     AH,0    ; a 3. mode helyett a 2-at rakljuk be
        JNE     nemez
        CMP     AL,3
        je      ezaz
        CMP     AL,3+80h
        je      ezaz
        jmp     nemez
ezaz:
        ;------------------
        PUSHF
        CALL dword ptr  cs:OLDINT    ; Jump to oldint

        MOV     AH,10h
        MOV     AL,3
        MOV     BL,0
        ;---------------------
nemez:  POPF
        JMP dword ptr  cs:OLDINT    ; Jump to oldint
NEWINT ENDP

;----------------------------------------------------------

FINISH          equ     $
MESSAGE         DB      'Blinking video mode (3) to 16 bgcol - JZ',CR,LF,BEEP,EOS
CHECKSUM        DW      0

INITCODE:
        MOV     AX,CS
        MOV     DS,AX
comment &
        PUSH    AX
        PUSH    CX
        PUSH    DX
        PUSH    SI
        PUSH    DS
        LEA     SI,DS:MESSAGE
        LEA     CX,DS:CHECKSUM
        SUB     CX,SI
        MOV     DX,0
checkloop:
        LODSB
        XOR     AL,0ABh
        MOV     AH,00h
        ADD     DX,AX
        LOOP    checkloop
        CMP     DL,0F0h
        JNE     error
        CMP     DH,01Eh
        JNE     error

        POP     DS
        POP     SI
        POP     DX
        POP     CX
        POP     AX
&
        MOV     AH,09h
        MOV     DX,offset MESSAGE
        INT     21h

        MOV     AH,35h
        MOV     AL,INTERRUPT
        INT     21h
        MOV     OLDINT[0],BX
        MOV     OLDINT[2],ES

        MOV     AH,25h
        MOV     AL,INTERRUPT
        MOV     DX,offset NEWINT
        INT     21h

        LEA     DX,FINISH
        INT     27h
error:
        INT     20h
OVERLAY ENDS
        end START
