#include <conio.h>
#include <dos.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <sys\stat.h>
#include <mem.h>
#include <alloc.h>
#include <ctype.h>

void put_vga_pixel(unsigned int x, unsigned int y , char col );
void vgainit( char mode );
void initmodes( int mod );

int xsize;
int ysize;
unsigned int extended_vga_xsize;
char current_vga_page,
     last_vga_page,
     color,
     videomode,
     readmode;

void vgainit( char mode )
{
 asm {
  mov ah,0
  mov al,mode
  int 10h
     }
}

void setxysize(int x,int y)
{
 xsize = x;
 ysize = y;
}

void initmodes( int videomode )
{
  vgainit( videomode );
  if ( videomode==19 ) setxysize(319,199);
  if ( videomode==92 ) setxysize(639,399);
  if ( videomode==93 ) setxysize(639,479);
  if ( videomode==94 ) setxysize(799,599);
  if ( videomode==98 ) setxysize(1023,767);
  extended_vga_xsize=xsize+1;
}

void put_vga_pixel(unsigned int x, unsigned int y , char col )
{
  asm {
       mov ax,x
       add ax,y
       mov dx,0
       mov bx,3
       mov bx,3
       div bx
       mov al,col
       mov color,al

     //extended_vga:
       mov dx,0xA000
       mov es,dx
       mov ax,extended_vga_xsize
       mul y
       add ax,x
       adc dx,0
       mov bx,ax
       mov current_vga_page,dl
       cmp dl,last_vga_page
       je put_pixel;
       jmp change_vga_page
     }
 vissza:
 put_pixel:
 asm {
      //put_pixel:
      mov ah,col
      mov es:[bx],ah
      jmp endpixel
     }

 change_vga_page:
 asm {
      mov ah,current_vga_page
      mov dx,0x3C4
      mov al,0xE
      out dx,al
      mov dx,0x3C5
      in al,dx
      and ax,0xFF0
      xor ah,2
      or al,ah
      out dx,al
      mov dl,current_vga_page
      mov last_vga_page,dl;
      jmp vissza
     }

 endpixel:;
}

void set_vga_page( char c_vga_page )
{
 asm {
      mov ah,c_vga_page
      mov dx,0x3C4
      mov al,0xE
      out dx,al
      mov dx,0x3C5
      in al,dx
      and ax,0xFF0
      xor ah,2
      or al,ah
      out dx,al
      mov dl,c_vga_page
      mov last_vga_page,dl;
     }
}


void makepalette( void )
{
 struct s_pt
  {
   char r,g,b;
  };
 s_pt pt[256];

 union REGPACK reg;

 char i;

 for (i=0; i<=63; i++)
  {
   pt[i].r=i; pt[i].g=i; pt[i].b=i;
   pt[127-i].r=i; pt[127-i].g=i; pt[127-i].b=i;
  }

 reg.r_ax = 0x10 << 8 | 0x12 ;
 reg.r_bx = 0;
 reg.r_cx = 128;
 reg.r_es = _DS;
 reg.r_dx = (unsigned)pt;

 intr(0x10, &reg);
}



void main ( int argc , char *argv[] )
{
 int c,ch;
 char mt[800];
 char mt2[800];
 char mt3[800];
 char mt4[800];
 char mtx[400];
 char at;

 initmodes( 19 );

 //put_vga_pixel (500,500,50 );
 //for (c=0 ; c<=255 ; c++ )
 // put_vga_pixel (c,c,c );
 int fh;
 int x,y;

 makepalette();

 y=0;
 fh=open(/*"$64.IMG"*/argv[1], O_BINARY | O_RDWR);

 while ( !eof(fh))
  {
   read(fh,mt,768);
   read(fh,mt2,768);
   read(fh,mt3,768);
   read(fh,mt4,768);
   for ( c=0 ; c<=767 ; c+=3 ) mtx[c/3]=(mt[c]+mt[c+1]+mt[c+2]+
                                         mt2[c]+mt2[c+1]+mt2[c+2]+
                                         mt3[c]+mt3[c+1]+mt3[c+2]+
                                         mt4[c]+mt4[c+1]+mt4[c+2]) / 12;
   for ( x=0 ; x<=767/3 ; x++ ) put_vga_pixel(x,y,mtx[x]/4 );
   y++;

   read(fh,mt,768);
   read(fh,mt2,768);
   read(fh,mt3,768);
   for ( c=0 ; c<=767 ; c+=3 ) mtx[c/3]=(mt[c]+mt[c+1]+mt[c+2]+
                                         mt2[c]+mt2[c+1]+mt2[c+2]+
                                         mt3[c]+mt3[c+1]+mt3[c+2]) / 9;
   for ( x=0 ; x<=767/3 ; x++ ) put_vga_pixel(x,y,mtx[x]/4 );
   y++;
  }

 close(fh);

 ch=toupper(getch());

 char far *scrn;
 char far *scrn2;
 char *sb;
 scrn=(char far *)MK_FP(0xA000,0);
 scrn2=(char far *)MK_FP(0xA000,32000);
 char fnev[50];

 if (ch=='S')
  {// SAVE SCREEN
   sb=(char *)malloc(32000);
   strcpy(fnev,argv[1]);
   fnev[strlen(fnev)-1]='!';

   fh=open( fnev, O_BINARY | O_RDWR | O_CREAT | O_TRUNC , S_IREAD|S_IWRITE );
   _fmemcpy( sb , scrn , 32000 );
   write( fh,sb, 32000 );
   _fmemcpy( sb , scrn2 , 32000 );
   write( fh,sb, 32000 );
   close(fh);
  }

 initmodes( 3 );
}

