#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <mem.h>


void drawpercent( int perc );

char buffer[256]; // Majd ms mret kell
char nulltomb[512*20];

/*
    --------------------    PASCAL (fuj) rsz:  --------------------

  bpbtyp  =  RECORD
               jmp: ARRAY[1..3] OF Byte;                           {Die ersten drei Bytes fr JUMP}
               oem: ARRAY[1..8] OF Char;                                              {OEM-Eintrag}
               bps: Word;                                                        {Bytes pro Sektor}
               spc: Byte;                                                    {Sektoren pro Cluster}
               res: Word;                                                           {BOOT-Sektoren}
               fat: Byte;                                                        {Anzahl der FAT's}
               rde: Word;                                                {Basisverzeichniseintrge}
               sec: Word;                                             {Gesamtsektoren der Diskette}
               mds: Byte;                                                        {Media-Deskriptor}
               spf: Word;                                                        {Sektoren pro FAT}
               spt: Word;                                                       {Sektoren pro Spur}
               hds: Word;                                                                  {Seiten}
               shh: LongInt;                                                  {Versteckte Sektoren}
               lse: LongInt;                                            {Lange Anzahl der Sektoren}
               pdn: Word;                                                   {Physical Drive Number}
               ebs: Byte;                                                 {Extended Boot Signature}
               vsn: LongInt;                                                 {Volume Serial-Number}
               vlb: ARRAY[1..11] OF Char;                                            {Volume Label}
               fsi: ARRAY[1..8] OF Char;                                           {File System Id}
               boot_code: boottyp;                                           {Puffer fr BOOT-Code}
             END;



*/

struct
  {
    char jmp[3];        //      Bar kis ugrs
    char oem[8];        //      OEM-ID-N
    unsigned int  bps;  //      {Bytes per Sector}
    char spc;           //      {Sektoren per Cluster}
    unsigned res;       //      {BOOT-Sektor}
    char fat;           //      {Number of FATs}
    unsigned rde;       //      {Rtdirektorientriz}
    unsigned tsec;       //      {Sectors on the diskette}
    char mds;           //      {Media-Descriptor}
    unsigned spf;       //      {Sektors   /  FAT}
    unsigned spt;       //       {Sektors  /  Spur}
    unsigned hds;       //       {Seiten}
    long shh;           //       {Versteckte Sektoren}
    long lse;           //       {Lange Anzahl der Sektoren}
    unsigned pdn;       //      {Physical Drive Number}
    char ebs;           //      {Extended Boot Signature}
    long vsn;           //      {Volume Serial-Number}
    char vlb[11];       //      {Volume Label}
    char fsi[8];        //      {File System Id}
    char boot_code[511-62+1]; //      {Buffer for BOOT-Code}
  }bpb;

char boot[512];

char ftab[][4]    ={{ 36,40, 9,2},
		    { 40,40,10,2},
		    { 72,80, 9,2},
		    { 80,80,10,2},
		    { 12,80,15,2},
		    {142,83,17,2},
                    {144,80,18,2},
                    { 15,83,18,2},
		    { 16,80,20,2},
		    {  0, 0, 0,0}};        //   <-- TERMINTOR


typedef char paratyp[0x0b];

paratyp para17  ={0xdf,0x02,0x25,0x02,17,0x02,0xff,0x23,0xf6,0x0f,0x08};
paratyp para18a ={0xdf,0x02,0x25,0x02,18,0x02,0xff,0x02,0xf6,0x0f,0x08};
paratyp para18  ={0xdf,0x02,0x25,0x02,18,0x02,0xff,0x6c,0xf6,0x0f,0x08};
paratyp para10  ={0xdf,0x02,0x25,0x02,10,0x02,0xff,0x2e,0xf6,0x0f,0x08};
paratyp para11  ={0xdf,0x02,0x25,0x02,11,0x02,0xff,0x02,0xf6,0x0f,0x08};
paratyp para15  ={0xdf,0x02,0x25,0x02,15,0x02,0xff,0x54,0xf6,0x0f,0x08};
paratyp para09  ={0xdf,0x02,0x25,0x02,9,0x02,0xff,0x50,0xf6,0x0f,0x08};
paratyp para08  ={0xdf,0x02,0x25,0x02,8,0x02,0xff,0x58,0xf6,0x0f,0x08};
paratyp para20  ={0xdf,0x02,0x25,0x02,20,0x02,0xff,0x2a,0xf6,0x0f,0x08};
paratyp para21  ={0xdf,0x02,0x25,0x02,21,0x02,0xff,0x0c,0xf6,0x0f,0x08};
paratyp para22  ={0xdf,0x02,0x25,0x02,22,0x02,0xff,0x01,0xf6,0x0f,0x08};
char  *paraptr;


int drive;
char dosdrive;
char para1E[0x0B] = {0xdf,0x02,0x25,0x02,0x09,0x02,0xff,0x50,0xf6,0x0f,0x08};

void ATSetDrive(char lw, char trk,char sec, char SetUp);
void feliromabootot(char size,int realsize,unsigned spt2);

signed int formaz ( char drive,int size, char v12=0 )
{
 int c,d,e;
 char size2=size;
 int all,ready,percent;
 int track=0,sect=0,head=255,set=0;
 char sbuf[512];
 REGPACK r;

 drawpercent(-2);

 c=0;
 while(ftab[c][0]!=0)
 {
  if (size==ftab[c][0])
  {
   track=ftab[c][1];
   sect =ftab[c][2];
   head =ftab[c][3];
  }
  c++;
 }

 switch(sect)
 {
  case  0:
  case  1:
  case  2:
  case  3:
  case  4:
  case  5:
  case  6:
  case  7:
  case  8: paraptr=(char *)para08;
   break;
  case  9: paraptr=para09;
   break;
  case 10: paraptr=para10;
   break;
  case 11: paraptr=para11;
   break;
  case 12:
  case 13:
  case 14:
  case 15: paraptr=para15;
   break;
  case 17: paraptr=para17;
   break;
  case 18: if (v12)paraptr=para18a;
              else paraptr=para18;
   break;

/*
     IF lwsec>17 THEN
      new1E:=@para18
     ELSE
      new1E:=@para18a;
*/
  case 19:
  case 20: paraptr=para20;
   break;
  case 21: paraptr=para21;
   break;
  default: paraptr=para22;
 }


 if (head==255) return (-1);


 ATSetDrive( drive , track, sect, set );

 unsigned SG1,OF1;

 SG1 = FP_SEG(paraptr);
 OF1 = FP_OFF(paraptr);

 asm {
      PUSH AX
      PUSH DX
      PUSH DS

      MOV AL,0x1E
      MOV AH,0x25
      MOV DS,SG1
      MOV DX,OF1
      INT 0x21

      POP DS
      POP DX
      POP AX
     }
 drawpercent( 0 );
 all=track;
 ready=0;

 for ( c=0; c<=track-1 ; c++ )
  {
   for ( d=0 ; d<=head-1 ; d++ )
    {
     //printf("Format %d %d\n",c,d);

     for ( e=0 ; e<=sect ; e++ )
      { sbuf[e*4] = c; sbuf[e*4+1] = d; sbuf[e*4+2] = e+1; sbuf[e*4+3] = 2;/*<!*/ }

     r.r_es = FP_SEG(sbuf);
     r.r_bx = FP_OFF(sbuf);
     r.r_dx = drive | (d << 8);
     r.r_ax = (5 << 8);
     r.r_cx = (c << 8);
     /*
     _DH=d;
     _DL=drive;
     _CH=c;
     _AH=
     */
     intr(0x13,&r);
    }

   drawpercent( (c+1)*100/all);

   if (kbhit())
    if (getch()==27)
     return(-1);
  }
 feliromabootot(size2,2*sect*track,(unsigned)sect);
 return (0);
}

/**********************************************************/

void ATSetDrive(char lw, char trk,char sec, char SetUp)
{
 union REGS regs;

 regs.h.dh = lw;
 regs.h.ah = 0x18;
 regs.h.ch = trk;
 regs.h.cl = sec;
 int86(0x13,&regs,&regs);

 if ( regs.h.ah>1 )
  {
   regs.h.ah = 0x17;
   regs.h.al = SetUp;
   regs.h.dl = lw;
   int86(0x13,&regs,&regs);
  }

 regs.h.dh=lw;
 regs.h.ah=0x18;
 regs.h.ch=trk;
 regs.h.cl=sec;
 int86(0x13,&regs,&regs);

 /*
 if (ForceType != 0)
  {
   lwtab[lw] = ForceType;
   bios = False;
  }
 else{
      if ( Disk2!=0 )
       {
	bios = False;
	lwtab[lw] = Disk2;
       }
      else
       {
	if ( !bios ) lwtab[lw] = Disk;
	DiskId = lwtab[lw];
       }
     }
 */
}

void bootbeolvas()
{
 int fh;
 fh=open("tfboot.sys",O_BINARY | O_RDONLY);
 read(fh,&bpb,512);
 close(fh);
 memset(nulltomb,0,512*20);
}

void feliromabootot(char size,int realsize,unsigned spt2)
{
 bootbeolvas();

 // ROOT DIR. ENTRIES  &   SECTORS/CLUSTER

 if (size==72 || size==36)
  {
   bpb.rde=0x0070;
   bpb.spc=2;
  }

 // TOTAL SECTORS

 bpb.tsec=realsize;

 //  MEFIA DECRIPTOR

 switch(size)
 {
  case 12:bpb.mds=0xF9; break;
  case 72:bpb.mds=0xf9; break;
  case 36:bpb.mds=0xFD; break;
 }

 // SECTORS / FAT

 switch(size)
 {
  case 142:
  case 144:
  case 150:bpb.spf=9; break;
  case  40:
  case  72:bpb.spf=3;    break;
  case  80:bpb.spf=5;    break;
  case  12:bpb.spf=7;    break;
  case  36:bpb.spf=2;    break;
  case  16:bpb.spf=0x0A; break;
 }

 // SECTORS / TRACK

 bpb.spt=spt2;

 asm push es
 asm push bx
 asm push ax
 asm push cx
 asm push dx

 _ES=FP_SEG(&bpb);
 _BX=FP_OFF(&bpb);

 _AH=3;                 // BOOT
 asm push ax
 _DL=drive;
 asm pop ax
 _DH=0;
 _CH=0;
 _CL=1;
 _AL=1;
 asm int 0x13


 _ES=FP_SEG(&nulltomb);
 asm push es
 _BX=FP_OFF(&nulltomb);
 asm pop es

 char c;
 char trk=0,sec=3,head=0;


 for (c=0;c<bpb.spf-1;c++)          // FAT-1     0000000000000000000
 {
  asm push ax
  asm push bx
  asm push cx
  asm push dx
  asm push es

  _ES=FP_SEG(&nulltomb);
  _BX=FP_OFF(&nulltomb);
  _CH=trk;
  _CL=sec;
  _AH=3;
  _DL=drive;
  _DH=head;
  _AL=1;

  asm int 0x13

  asm pop es
  asm pop dx
  asm pop cx
  asm pop bx
  asm pop ax
  sec++;
  if (sec>bpb.spt)
  {
   sec=1;
   head=1-head;
   if (head==0) trk++;
  }
 }

 trk=0;
 head=0;
 sec=1;
 for (c=2;c<=2+bpb.spf+1;c++)
 {
  sec++;
  if (sec>bpb.spt)
   {
    sec=1;
    head=1-head;
    if (head==0)trk++;
   }
 }



 for (c=0;c<bpb.spf-1;c++)          // FAT-2     0000000000000000000
 {
  asm push ax
  asm push bx
  asm push cx
  asm push dx
  asm push es

  _ES=FP_SEG(&nulltomb);
  _BX=FP_OFF(&nulltomb);
  _CH=trk;
  _CL=sec;
  _AH=3;
  _DL=drive;
  _DH=head;
  _AL=1;

  asm int 0x13

  asm pop es
  asm pop dx
  asm pop cx
  asm pop bx
  asm pop ax
  sec++;
  if (sec>bpb.spt)
  {
   sec=1;
   head=1-head;
   if (head==0) trk++;
  }
 }

 trk=0;
 head=0;
 sec=1;
 for (c=2;c<=2+2*bpb.spf;c++)
 {
  sec++;
  if (sec>bpb.spt)
   {
    sec=1;
    head=1-head;
    if (head==0)trk++;
   }
 }


 for (c=0;c<bpb.rde*32/512;c++)          // ROOT     0000000000000000000
 {
  asm push ax
  asm push bx
  asm push cx
  asm push dx
  asm push es

  _ES=FP_SEG(&nulltomb);
  _BX=FP_OFF(&nulltomb);
  _CH=trk;
  _CL=sec;
  _AH=3;
  _DL=drive;
  _DH=head;
  _AL=1;

  asm int 0x13

  asm pop es
  asm pop dx
  asm pop cx
  asm pop bx
  asm pop ax
  sec++;
  if (sec>bpb.spt)
  {
   sec=1;
   head=1-head;
   if (head==0) trk++;
  }
 }

 asm push es
 asm push bx
 asm push ax
 nulltomb[0]=bpb.mds;
 nulltomb[1]=0xFF;
 nulltomb[2]=0xFF;
 asm pop ax
 asm pop bx
 asm pop es

 _AH=3;                                // FAT-1  FFFFFFFFFFFFFFFFFFFFF
 _DL=drive;
 _DH=0;
 _CL=2;
 _CH=0;
 _AL=1;
 asm int 0x13

 _AH=3;                                // FAT-2  FFFFFFFFFFFFFFFFFFFFF
 asm push ax
 _CL=2+bpb.spf;
 asm pop ax
 asm int 0x13


 asm pop dx
 asm pop cx
 asm pop ax
 asm pop bx
 asm pop es

}


void drivetip(char drive, char *hd, char *trk, char *sec, char *tip)
{
 union REGS regs;
 regs.x.ax=0x4409; regs.x.bx=drive+1;
 int86(0x21,&regs,&regs);
 asm JC  nodrive
 asm JMP vandrive
 nodrive:
   *trk=0;
   return;
 vandrive:
 if ((regs.x.dx & 0x9200)!=0)
 {
   *trk=0;
   return;
 }
 regs.x.ax=0x440f; regs.x.bx=drive+1;
 int86(0x21,&regs,&regs);
 asm JC nodrive

 asm push AX
 asm push BX
 asm push CX
 asm push DX
 asm push DS

 _DX=FP_OFF(buffer); // ax-et mod.-ja (!!!), azert
 _DS=FP_SEG(buffer); // kell _AX=... ele tenni
 _BL=drive+1; // ez is !!!
 _AX=0x440d;
 _CX=0x860;
 _BH=0;
 buffer[0]=0;
 asm int 21h

 asm pop DS
 asm pop DX
 asm pop CX
 asm pop BX
 asm pop AX

 dosdrive=buffer[1];
 /*
 IF cfgdrive<>255 THEN
   dosdrive:=cfgdrive;
 */
 switch(dosdrive)
 {
   case 0: *trk=39; *sec= 9; *hd=0; *tip=0; break; // 5.25 DD
   case 1: *trk=79; *sec=15; *hd=1; *tip=0; break; // 5.25 HD
   case 2: *trk=79; *sec= 9; *hd=0; *tip=1; break; // 3.5 DD
   case 7: *trk=79; *sec=18; *hd=1; *tip=1; break; // 3.5 HD
   default:
     {
       *trk=0;
       return;
     }
 }
 /*
 GetPhysical(lw);
 lw:=lw AND $9f;
 IF NOT(lw IN [0..3]) THEN BEGIN
   WriteLn(text07);
   trk:=0;
   Exit;
 END;
 IF cfgat80 THEN
   at80:=cfgat80
 ELSE
   at80:=(ModelByte=$f8) OR (ModelByte=$fc);
 */

}

/*
void main( void )
{
 formaz(0,80);
}
*/