#include <graphics.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <fcntl.h>
#include <alloc.h>
#include <dos.h>
#include <ctype.h>
#include <sys\stat.h>
#include <dir.h>

#include "zzcode.h"
#include "zzfiles.h"
#include "zzdata.h"
#include "..\LZW\LZW4C.h"

#define doZZLite  0  //  1 - if you wan't to do ZigZag Lite

#define ALWAYSCRYPT 1

#define ANYAGDIR   "ANYAG" // knyvtr neve, ahol az anyagok vannak
#define SYSDIR    "SYSTEM" // knyvtr neve, ahol az system dolgok vannak

void loadtitles( void );
void loadxtitles( void );

long calcowncrc ( char *fnev,void (*statdisp)(long,long) = NULL);

scim cim[200];

scim xfiles[100];

long datastart=0L; // data start in EXE
char dsazon[10+1]={" < &%$^"};

int maxcim,xmaxcim;

sheader fhead = { 0l,"NOSASOFT DATA",0l,0,F_DATAVER, 0 };

s_fdentry de;

char buf[15002];

int isZZLite;

int readf,writef;
long rcc,wcc;
char rt[4001];
int rtc=-1,rtmc=-1;
int readfun();
int writefun( int mit );

int readfun()
{
 int yy;
 if (rtc==rtmc || (rtc==-1))
  {
   rtc=0;
   yy=read(readf,rt,4000);
   printf(".");
   if (yy==0)
    return(-1);
   rtmc=yy;
  }

 yy=rt[rtc];
 yy=yy&0x00FF; // not necessary .?
 rtc++;
 rcc++;
 return yy;
}

int writefun( int mit )
{
 wcc++;
 return (write(writef,&mit,1));
}

void main( void )
{
 int c,d;
 int fh,fh2;
 char *s;
 long cn1,cn2,fs,fps;
 char last;

 InitLZW((char*(*)())malloc);

 fhead.isZZLite = doZZLite;

 isZZLite = doZZLite;

 loadtitles();
 loadxtitles();

 printf("------------------------------------------\n");
 printf("--  NOSASOFT ZigZag file maker utility  --\n");
 printf("------------------------------------------\n");

 fh = open("ZIGZAG.000",O_BINARY|O_RDWR,S_IREAD|S_IWRITE);
 if (fh==-1)
  {
   printf("No EXE!\n");
   return;
  }

 char bf[20];
 long l1;
 lseek(fh,filelength(fh)-10,SEEK_SET);
 read(fh,bf,10);
 if (memcmp(bf,dsazon,10)==0)
  {
   lseek(fh,filelength(fh)-14,SEEK_SET);
   read(fh,&datastart,4);
   printf("Replacing data from offset %li...\n",datastart);
   chsize(fh,datastart);
   //lseek(fh,datastart,SEEK_SET);
   lseek(fh,0,SEEK_END);
   datastart=tell(fh);
  }
 else
  {
   lseek(fh,0,SEEK_END);
   datastart=tell(fh);
  }

 write( fh , &fhead, sizeof(fhead) );

 for ( c=0 ; /*strcmp(cim[c].title,"")!=0 &&*/ (cim[c].title) ; c++ )
  {
   if (strcmp(cim[c].filenev,"")==0)
    continue;

   strncpy( de.name,cim[c].filenev,12 );
   for ( d=0,s=de.name ; (*s!='\0') && (d<15) ; s++,d++ ) *s=toupper(*s);
   write(fh,&de,sizeof(de));
   fhead.dirents++;

   if ( (cim[c].tipus==T_EXTRACTABLE || cim[c].tipus==T_BOTHEXT) && (!isZZLite) )
    {
     strncpy( de.name,cim[c].exfilenev,12 );
     for ( d=0,s=de.name ; (*s!='\0') && (d<15) ; s++,d++ ) *s=toupper(*s);
     write(fh,&de,sizeof(de));
     fhead.dirents++;
    }
  }

 for ( c=0 ; /*strcmp(xfiles[c].title,"")!=0 &&*/ (xfiles[c].title) ; c++ )
  {
   if (strcmp(xfiles[c].filenev,"")==0)
    continue;

   strncpy( de.name,xfiles[c].filenev,12 );
   for ( d=0,s=de.name ; (*s!='\0') && (d<15) ; s++,d++ ) *s=toupper(*s);
   write(fh,&de,sizeof(de));
   fhead.dirents++;

   if ( (xfiles[c].tipus==T_EXTRACTABLE || cim[c].tipus==T_BOTHEXT) && (!isZZLite) )
    {
     strncpy( de.name,xfiles[c].exfilenev,12 );
     for ( d=0,s=de.name ; (*s!='\0') && (d<15) ; s++,d++ ) *s=toupper(*s);
     write(fh,&de,sizeof(de));
     fhead.dirents++;
    }
  }

 long csum;
 long siztot=0,ftot=0;
 char fname[50];
 char hanyadek;

 for ( c=0 ; c<fhead.dirents ; c++ )
  {
   lseek(fh,sizeof(fhead)+c*sizeof(de)+datastart,SEEK_SET);
   read(fh,&de,sizeof(de));

   fps=filelength(fh);
   de.start=fps;

   sprintf(fname,"%s\\%s",ANYAGDIR,de.name);

   printf("%s ",de.name);

   fh2 = open( fname,O_BINARY|O_RDONLY );

   if (fh2==-1)
    {
     sprintf(fname,"%s\\%s",SYSDIR,de.name);
     fh2 = open( fname,O_BINARY|O_RDONLY );
     if (fh2==-1)
      {
       sprintf(fname,"%s",de.name);
       fh2 = open( fname,O_BINARY|O_RDONLY );
       if (fh2==-1)
	{
	 printf(" - Error -\r\n");
	 continue;
	}
      }
    }

   fs = filelength( fh2 );
   de.size = fs;
   lseek(fh,fps,SEEK_SET);

   char drive[MAXDRIVE];
   char dir[MAXDIR];
   char file[MAXFILE];
   char ext[MAXEXT];
   int flags;
   flags=fnsplit(fname,drive,dir,file,ext);

   //csum=0;

   if ((stricmp(ext,".GIF")==0)||(stricmp(ext,".PCX")==0)||(stricmp(ext,".EXE")==0)
    ||(ALWAYSCRYPT))
    {
     printf(" -Crypting- ");
     last=DEFINIALTLAST;
     hanyadek=0;
     cn1=fs;
     while( cn1>0 )
      {
       cn2=(cn1>15000) ? 15000 : cn1;
       cn1-=cn2;
       read(fh2,buf,cn2);
       if (cn1==0) // This is the last R/W
	{ // Store ChkSum
	 memcpy(&de.chksum,&buf[cn2-sizeof(long)],sizeof(long));
	}
       printf(".");

       codetomb(buf,cn2,&last,&hanyadek);
       //printf("\x8o");

       //for (d=0 ; d<cn2 ; d++ ) csum+=buf[d]; //csum+=buf[d]*((d%50)*2);

       write(fh,buf,cn2);
       printf(".");
      }
     de.method=0; // encrypted
     wcc=rcc=de.size;
     ftot+=de.size;
    }
   else
    {
     printf(" -Compressing- ");
     rcc=wcc=0;
     rtc=-1;
     readf=fh2;
     writef=fh;
     Compress(readfun,(int(*)())writefun);
     de.method=2; // compressed
     de.csize=wcc;
     ftot+=de.csize;
    }

   siztot+=de.size;
   //printf(" %li Kb\r\n",de.size/1024 + 1 );

   printf(" %li - %li bytes\r\n",rcc,wcc);

   //de.chksum=csum;
   lseek(fh,sizeof(fhead)+c*sizeof(de)+datastart,SEEK_SET);
   write(fh,&de,sizeof(de));

   close(fh2);
  }

 lseek(fh,0+datastart,SEEK_SET);
 write( fh , &fhead, sizeof(fhead) );

 lseek(fh,0,SEEK_END);
 write(fh,&datastart,4);
 write(fh,dsazon,10);

 printf("-----------------------------------------\n");
 printf("Total : %d files, %li Kb -> %li Kb\r\n",fhead.dirents,siztot/1024,ftot/1024);
 close(fh);

 long lg;

 //printf("Computing CRC...\r\n");
 //lg = calcowncrc("ZigZag.NSS");

 //fh = open("ZIGZAG.NSS",O_BINARY|O_RDWR);
 //write(fh,&lg,sizeof(lg));
 //close( fh );

 TermLZW((int(*)())free);
}

/*-----------------------------------------------------------*/

void loadtitles( void )
{
 int f;
 long fs;
 char *buf;
 char  *p, *q;
 char sor[203]; // semelyik sor nem lehet hosszabb 200 kar-nl!
 char *dst;
 int c,cn=0;
 int deltacn=0;
 unsigned xx;

 f = open("ANYAG\\ZigZagLX.TXT",O_RDONLY|O_BINARY);
 if (f==-1)
  {
   printf("\r\nANYAG\\ZigZagLX.TXT control file not found !\r\n");
   exit(1);
  }
 fs = filelength(f);
 buf = (char *)malloc(fs+1);
 read(f,buf,fs);
 buf[fs]='\0';

 p = buf;
 while ( fs>p-buf )
  {
   for (c=0; *p!='\0' && *p!='\r' && *p!='\n' && c<200; sor[c]=*p,p++,c++)  ;
   sor[c]='\0'; p++;
   while ( *p=='\n' || *p=='\r' ) p++;

   for (q=&sor[0]; *q!='\0' && *q==' '; q++ )  ;
   if ( *q=='\0' || *q==';' )
    continue;

   cn+=deltacn; deltacn=0;

   q=strtok(sor,"|");
   if (q==NULL)
    continue;
   while (*q==' ') q++; q++; // "
   dst=(char *)malloc(strchr(q,'\"')-q+1);
   _fstrncpy(dst,q,strchr(q,'\"')-q); dst[strchr(q,'\"')-q]='\0';
   cim[cn].title = dst;

   q=strtok(NULL,"|");
   if (q==NULL)
    continue;
   while (*q==' ') q++; q++; // "
   dst=(char *)malloc(strchr(q,'\"')-q+1);
   _fstrncpy(dst,q,strchr(q,'\"')-q); dst[strchr(q,'\"')-q]='\0';
   cim[cn].filenev = dst;

   deltacn=1;

   q=strtok(NULL,"|");
   if (q==NULL)
    continue;
   while (*q==' ') q++;
   dst=(char *)malloc(strchr(q,'\"')-q+1);
   _fstrncpy(dst,q,strchr(q,'\"')-q); dst[strchr(q,'\"')-q]='\0';
   c=cikktype(q);

   cim[cn].tipus = c;
   free(dst);

   q=strtok(NULL,"|");
   if (q==NULL)
    continue;
   while (*q==' ') q++; q++; // "
   dst=(char *)malloc(strchr(q,'\"')-q+1);
   _fstrncpy(dst,q,strchr(q,'\"')-q); dst[strchr(q,'\"')-q]='\0';
   cim[cn].exfilenev = dst;
  }
 maxcim = cn+deltacn-1;

 free(buf);
 close(f);
}


void loadxtitles( void )
{
 int f;
 long fs;
 char *buf;
 char *p, *q;
 char sor[203]; // semelyik sor nem lehet hosszabb 200 kar-nl!
 char *dst;
 int c,cn=0;
 int deltacn=0;

 f = open("SYSTEM\\ZigZagXF.TXT",O_RDONLY|O_BINARY);
 if (f==-1)
  {
   printf("\r\nSYSTEM\\ZigZagXF.TXT control file not found !\r\n");
   exit(1);
  }
 fs = filelength(f);
 buf = (char *)malloc(fs+1);
 read(f,buf,fs);
 buf[fs]='\0';

 p = buf;
 while ( fs>p-buf )
  {
   for (c=0; *p!='\0' && *p!='\r' && *p!='\n' && c<200; sor[c]=*p,p++,c++)  ;
   sor[c]='\0'; p++;
   while ( *p=='\n' || *p=='\r' ) p++;

   for (q=&sor[0]; *q!='\0' && *q==' '; q++ )  ;
   if ( *q=='\0' || *q==';' )
    continue;

   cn+=deltacn; deltacn=0;

   q=strtok(sor,"|");
   if (q==NULL)
    continue;
   while (*q==' ') q++; q++; // "
   dst=(char *)malloc(strchr(q,'\"')-q+1);
   _fstrncpy(dst,q,strchr(q,'\"')-q); dst[strchr(q,'\"')-q]='\0';
   xfiles[cn].title = dst;

   q=strtok(NULL,"|");
   if (q==NULL)
    continue;
   while (*q==' ') q++; q++; // "
   dst=(char *)malloc(strchr(q,'\"')-q+1);
   _fstrncpy(dst,q,strchr(q,'\"')-q); dst[strchr(q,'\"')-q]='\0';
   xfiles[cn].filenev = dst;

   deltacn=1;

   q=strtok(NULL,"|");
   if (q==NULL)
    continue;
   while (*q==' ') q++;
   dst=(char *)malloc(strchr(q,'\"')-q+1);
   _fstrncpy(dst,q,strchr(q,'\"')-q); dst[strchr(q,'\"')-q]='\0';

   c=cikktype(q);

   xfiles[cn].tipus = c;
   free(dst);

   q=strtok(NULL,"|");
   if (q==NULL)
    continue;
   while (*q==' ') q++; q++; // "
   dst=(char *)malloc(strchr(q,'\"')-q+1);
   _fstrncpy(dst,q,strchr(q,'\"')-q); dst[strchr(q,'\"')-q]='\0';
   xfiles[cn].exfilenev = dst;
  }
 xmaxcim = cn+deltacn-1;

 free(buf);
 close(f);
}

